//+------------------------------------------------------------------+
//|                                                   mysql_link.mq5 |
//|                                                            Graff |
//|                            https://login.mql5.com/ru/users/Graff |
//+------------------------------------------------------------------+
#property copyright "Graff"
#property link      "https://login.mql5.com/ru/users/Graff"
#property version   "1.00"

#import "libmysql.dll"
int mysql_get_client_info(); //   char*

int mysql_init(int db);
int mysql_errno(int TMYSQL);
int mysql_real_connect(int TMYSQL,string &host,string &user,string &password,
                       string &DB,int port,int socket,int clientflag);
int mysql_real_query(int TMYSQL,string &query,int lenght);
void mysql_close(int TMSQL);
string mysql_error(int TMYSQL); //string is ansi

int mysql_fetch_row(int result);
//Mysql_row mysql_fetch_row(int result);
int mysql_store_result(uint TMSQL);
int mysql_num_rows(uint result);
int mysql_num_fields(uint result);
void mysql_free_result(uint result);

int mysql_fetch_lengths(uint result);
int mysql_fetch_field_direct(uint result,uint fieldnr);
#import "msvcrt.dll"
int strcpy(uchar &strDestination[],int strSource); //  NULL-  source    
int strcpy(string strDestination,int strSource); //  NULL-  source    

int memcpy(uchar &Destination[],uchar &Source[],int Length);
int memcpy(uchar &Destination[],int Source,int Length);
int memcpy(int Destination,uchar &Source[],int Length);

int memcpy(int &Destination[],int Source,int Length);
#import

string MySqlHost="localhost"; //MySql Host:
string MySqlUser="root";     //MySQL User:
string MySqlPass="1";      //MySQL Password:
string MySqlDB     ="forex";     //MySQL Table:
int    MySqlPort   =3306;        //MySQL Port:
int mysql=0;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   string host,user,pass,DB;
   if(MQL5InfoInteger(MQL5_DLLS_ALLOWED)==0)
     {
      Alert("DLL calling not allowed. Allow and try again!");
     }
   mysql=mysql_init(0);
   Print("obiectul mysql=",mysql);
   host=UNICODE2ANSI(MySqlHost);
   user=UNICODE2ANSI(MySqlUser);
   pass=UNICODE2ANSI(MySqlPass);
   DB=UNICODE2ANSI(MySqlDB);
   int res=mysql_real_connect(mysql,host,user,pass,DB,MySqlPort,"",0);
   Print("connection result=",res);
   if(res==mysql)
      Print("Successfully connected to the MySQL server!");
   else
     {
      string s;
      s=mysql_error(mysql);
      Print("Eroare de conectare = ",ANSI2UNICODE(s));
      return;
     }
   getSTRField("SELECT * FROM `ODB_t1`");

  }
//+------------------------------------------------------------------+
//| Get single field String value from MySQL                                      |
//+------------------------------------------------------------------+  
string getSTRField(string query2)
  {
   string ansiquery;

   ansiquery=UNICODE2ANSI(query2);

   int length=StringLen(query2);

   int res2=mysql_real_query(mysql,ansiquery,length);

   if(res2!=0)
     {
      Print("result of query  != 0!!  mysql:  "+IntegerToString(mysql));
      Comment("getSTRField","query result","mysgl:",IntegerToString(mysql));
      int mysqlerr=mysql_errno(mysql);
      if(mysqlerr>0)
        {
         Print("Query: ",query2);
         Print("Returned error: ",ANSI2UNICODE(mysql_error(mysql)));
         Comment("Returned error: ",ANSI2UNICODE(mysql_error(mysql)));
        }
     }
   int res_store=mysql_store_result(mysql);

   if(res_store==0)
     {
      Print("ANSI2UNICODE(mysql_error(mysql)) ); = 0!!");
      Print("GetLastError MySQL:  "+DoubleToString(GetLastError(),0));
      Comment("getSTRField","GetLastError",DoubleToString(GetLastError(),0));
      return("");
     }
   int numOfRows=mysql_num_rows(res_store);
   int num_fields=mysql_num_fields(res_store);

   if(numOfRows==0)
     {
      Comment("No row found; ",query2);
      return("");
     }

   string res;

   for(int r=0;r<numOfRows;r++)
     {
      int crow=mysql_fetch_row(res_store);
      int lens=mysql_fetch_lengths(res_store);

      int alens[];
      ArrayResize(alens,num_fields);
      memcpy(alens,lens,num_fields);
      // getting curr row
      int arows[];
      ArrayResize(arows,num_fields);
      memcpy(arows,crow,num_fields);
      
      for(int f=0;f<num_fields;f++)
        {
         uchar byte[];// int ptr;
         ArrayResize(byte,alens[f]);
         memcpy(byte,arows[f],alens[f]);
         res+=CharArrayToString(byte)+"|";
         Print(CharArrayToString(byte)," | len: ",alens[f]," | row: ",arows[f]);
        }
      res+="\n";
     }
   Comment(res);

   mysql_free_result(res_store);
   mysql_close(mysql);
   return(res);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void sql_query(string _query)
  {
   string ansiquery;
   int length=StringLen(_query);
   ansiquery=UNICODE2ANSI(_query);
   mysql_real_query(mysql,ansiquery,length);
   int mysqlerr=mysql_errno(mysql);
   if(mysqlerr>0)
     {
      Print("Query: ",_query);
      Print("Returned error: ",ANSI2UNICODE(mysql_error(mysql)));
     }
   return;
  }
//+------------------------------------------------------------------+
string ANSI2UNICODE(string s)
  {
   ushort mychar;
   long m,d;
   double mm,dd;
   string img;
   string res="";
   if(StringLen(s)>0)
     {
      string g=" ";
      for(int i=0;i<StringLen(s);i++)
        {
         string f="  ";
         mychar=ushort(StringGetCharacter(s,i));
         mm=MathMod(mychar,256);
         img=DoubleToString(mm,0);
         m=StringToInteger(img);
         dd=(mychar-m)/256;
         img=DoubleToString(dd,0);
         d=StringToInteger(img);
         if(m!=0)
           {
            StringSetCharacter(f,0,ushort(m));
            StringSetCharacter(f,1,ushort(d));
            StringConcatenate(res,res,f);
           }//if (m!=0)
         else
            break;
        }//for (int i=0;i<StringLen(s);i++)
     }//if (StringLen(s)>0)
   return(res);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string UNICODE2ANSI(string s)
  {
   int leng,ipos;
   uchar m,d;
   ulong big;
   leng=StringLen(s);
   string unichar;
   string res="";
   if(leng!=0)
     {
      unichar=" ";
      ipos=0;
      while(ipos<leng)
        { //uchar typecasted because each double byte char is actually one byte
         m=uchar(StringGetCharacter(s,ipos));
         if(ipos+1<leng)
            d=uchar(StringGetCharacter(s,ipos+1));
         else
            d=0;
         big=d*256+m;
         StringSetCharacter(unichar,0,ushort(big));
         StringConcatenate(res,res,unichar);
         ipos=ipos+2;
        }
     }
   return(res);
  }
//+------------------------------------------------------------------+
